#!/usr/bin/env bash
###################################################
# Generated by render-templates.ts, DO NOT MODIFY #
###################################################

set -e -u -o pipefail
shopt -s inherit_errexit
DIRTY_FILES="$(git status --porcelain)"
if [ "$DIRTY_FILES" != "" ]; then
  echo "Error: git repo has uncommitted changes, refusing to build as the result may not be reproducible" 1>&2
  echo "$DIRTY_FILES" 1>&2
  exit 1
fi

COMMIT_TAG="$(git describe --exact-match HEAD 2>/dev/null)"
if [ "$COMMIT_TAG" != "v2.0.2" ]; then \
  echo "Error: build-release-image.sh must be run from a checkout of tag v2.0.2" 1>&2
  exit 1
fi

COMMIT_FULL_HASH="$(git rev-parse HEAD)"

IIDFILE_0="$(mktemp)"
${DOCKER_CMD:-docker} image build \
  --iidfile "${IIDFILE_0:?}" \
  --target "slim" \
  --tag "registry.gitlab.developers.cam.ac.uk/lib/dev/common/docker-compose-pipelines:2-slim" \
  --tag "registry.gitlab.developers.cam.ac.uk/lib/dev/common/docker-compose-pipelines:2.0-slim" \
  --tag "registry.gitlab.developers.cam.ac.uk/lib/dev/common/docker-compose-pipelines:2.0.2-slim" \
  .

IIDFILE_1="$(mktemp)"
${DOCKER_CMD:-docker} image build \
  --iidfile "${IIDFILE_1:?}" \
  --target "full" \
  --tag "registry.gitlab.developers.cam.ac.uk/lib/dev/common/docker-compose-pipelines:2" \
  --tag "registry.gitlab.developers.cam.ac.uk/lib/dev/common/docker-compose-pipelines:2.0" \
  --tag "registry.gitlab.developers.cam.ac.uk/lib/dev/common/docker-compose-pipelines:2.0.2" \
  .

# We emit a JSON object on stdout containing event data describing the build
# that has occured. This event may be persisted to the project's event log to
# allow future operations to operate on this information.
IMAGE_ID_0="$(cat "${IIDFILE_0:?}")"
BUILT_IMAGE_JSON_0="$(jq \
  --null-input \
  --arg dockerfile Dockerfile \
  --arg target "slim" \
  --arg id "${IMAGE_ID_0:?}" \
  --argjson repoTags '["registry.gitlab.developers.cam.ac.uk/lib/dev/common/docker-compose-pipelines:2-slim","registry.gitlab.developers.cam.ac.uk/lib/dev/common/docker-compose-pipelines:2.0-slim","registry.gitlab.developers.cam.ac.uk/lib/dev/common/docker-compose-pipelines:2.0.2-slim"]' \
  '{ dockerfile: $dockerfile, target: $target, id: $id, repoTags: $repoTags }' \
)"
IMAGE_ID_1="$(cat "${IIDFILE_1:?}")"
BUILT_IMAGE_JSON_1="$(jq \
  --null-input \
  --arg dockerfile Dockerfile \
  --arg target "full" \
  --arg id "${IMAGE_ID_1:?}" \
  --argjson repoTags '["registry.gitlab.developers.cam.ac.uk/lib/dev/common/docker-compose-pipelines:2","registry.gitlab.developers.cam.ac.uk/lib/dev/common/docker-compose-pipelines:2.0","registry.gitlab.developers.cam.ac.uk/lib/dev/common/docker-compose-pipelines:2.0.2"]' \
  '{ dockerfile: $dockerfile, target: $target, id: $id, repoTags: $repoTags }' \
)"


# The built image objects are passed to jq on stdin as a stream. We need --seq
# to make jq produce application/json-seq, but this also makes jq expect
# application/json-seq on input, so we must encode the input accordingly by
# starting JSON objects with ASCII record separator (\x1e) and ending with a
# newline.
BUILT_IMAGES_JSON="$(printf '\x1e%s\n' "${BUILT_IMAGE_JSON_0:?}" "${BUILT_IMAGE_JSON_1:?}")"
DATE="$(date --rfc-3339=seconds --utc)"
<<<"${BUILT_IMAGES_JSON:?}" \
jq --null-input --seq \
  --arg date "${DATE:?}" \
  --arg event ReleaseImagesBuilt \
  --arg releaseGitTag "v2.0.2" \
  --arg releaseGitCommit "${COMMIT_FULL_HASH:?}" \
  '[inputs] as $builtImages | {
    event: $event,
    date: $date,
    releaseGitTag: $releaseGitTag,
    releaseGitCommit: $releaseGitCommit,
    images: $builtImages
  } | del(.[] | select(. == null))' \
  || exit 1
